program scroller;

uses
  Windows, Messages;

{$R *.res}

type
  LPMSLLHOOKSTRUCT = ^MSLLHOOKSTRUCT;
  MSLLHOOKSTRUCT = record
    pt: TPOINT;
    mouseData: DWORD;
    flags: DWORD;
    time: DWORD;
    dwExtraInfo: Pointer;
  end;

const
  WH_MOUSE_LL = 14;

  BELOW_NORMAL_PRIORITY_CLASS = $00004000;
  ABOVE_NORMAL_PRIORITY_CLASS = $00008000;

var
  HOOK: HHOOK;
  Running: boolean;
  PID: DWord;

function LowLevelMouseProc(nCode: integer; wParam: WPARAM; lparam: LPARAM): LRESULT; stdcall;
begin
if wParam = WM_MOUSEWHEEL then begin
  SendMessage(WindowFromPoint(LPMSLLHOOKSTRUCT(lparam).pt),
    WM_MOUSEWHEEL, LPMSLLHOOKSTRUCT(lparam).mouseData,
    MakeLong(LPMSLLHOOKSTRUCT(lparam).pt.X, LPMSLLHOOKSTRUCT(lparam).pt.Y));
  Result:=-1;
  end else Result:=CallNextHookEx(HOOK, nCode, wParam, lParam);
end;

function ProcessMessage: boolean;
var
  AMessage: TMsg;
begin
Result:=False;
if PeekMessage(AMessage, INVALID_HANDLE_VALUE, 0, 0, PM_REMOVE) then
  begin
  Result:=True;
    case AMessage.message of
      WM_QUIT: running:=false;
    end;
  end;
end;

begin
PID:=OpenProcess(GENERIC_ALL, false, GetCurrentProcessId);
SetPriorityClass(PID, ABOVE_NORMAL_PRIORITY_CLASS);
CloseHandle(PID);
try
  HOOK:=SetWindowsHookEx(WH_MOUSE_LL, @LowLevelMouseProc, hInstance, 0);
  except ExitProcess(1) end;
running:=true;
while running do if not ProcessMessage then WaitMessage;
if HOOK <> 0 then UnhookWindowsHookEx(HOOK);
end.
